#include "msl.hpp"

int
main()
{
	namespace v = msl::var;
	std::mt19937 gnr{};
	std::uniform_real_distribution<> unif(0, 1);
	auto popul{ msl::load_population("population-2024") };
	for (int t{ 2025 }; t < 2025 + 50; ++t) {
		msl::to_day = msl::days_from_civil(t, 12, 31); // Last of december
		msl::load_parameters("parameters.xlsx", t);
		popul.for_each(
		  MSL_FNCTN(ref.prob = ref.female() && msl::within(20, ref.age(), 40) ? 2. / (40 - 20) : 0));
		popul.align(msl::prm::births_nr, v::prob, [&](msl::Ref mother) {
			msl::Ref baby{ popul.birth(mother, msl::to_day - gnr() % 365) };
			baby.set_female(unif(gnr) < .48);
		});
		popul.for_each(MSL_FNCTN(ref.prob = ref.age() > 60 ? .05 : 0));
		popul.align(msl::prm::deaths_nr, v::prob, MSL_FNCTN(ref.death()));
		std::cout << t << '\t' << popul.count_if(v::one) << '\t' << popul.avg(MSL_LMBD(ref.age()))
		          << '\n';
	}
	return 0;
}
